## org.apache.mahout.math.hadoop.stochasticsvd
Class BtJob

    java.lang.Object
      org.apache.mahout.math.hadoop.stochasticsvd.BtJob

    public final class BtJob

extends Object

Bt job. For details, see working notes in MAHOUT-376.

Uses hadoop deprecated API wherever new api has not been updated (MAHOUT-593), hence @SuppressWarning("deprecation").

This job outputs either Bt in its standard output, or upper triangular matrices representing BBt partial sums if that's requested . If the latter mode is enabled, then we accumulate BBt outer product sums in upper triangular accumulator and output it at the end of the job, thus saving space and BBt job.

This job also outputs Q and Bt and optionally BBt. Bt is output to standard job output (part-*) and Q and BBt use named multiple outputs.

Nested Class Summary
`static class` `BtJob.BtMapper`
`static class` `BtJob.OuterProductCombiner`
`static class` `BtJob.OuterProductReducer`

Field Summary
`static String` `OUTPUT_BBT`
`static String` `OUTPUT_BT`
`static String` `OUTPUT_Q`
`static String` `OUTPUT_SB`
`static String` `OUTPUT_SQ`
`static String` `PROP_NV`
`static String` `PROP_OUPTUT_BBT_PRODUCTS`
`static String` `PROP_OUTER_PROD_BLOCK_HEIGHT`
`static String` `PROP_QJOB_PATH`
`static String` `PROP_RHAT_BROADCAST`
`static String` `PROP_XI_PATH`

Method Summary
`static void` `run(org.apache.hadoop.conf.Configuration conf, org.apache.hadoop.fs.Path[] inputPathA, org.apache.hadoop.fs.Path inputPathQJob, org.apache.hadoop.fs.Path xiPath, org.apache.hadoop.fs.Path outputPath, int minSplitSize, int k, int p, int btBlockHeight, int numReduceTasks, boolean broadcast, Class<? extends org.apache.hadoop.io.Writable> labelClass, boolean outputBBtProducts)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### OUTPUT_Q

    public static final String OUTPUT_Q

See Also:
  Constant Field Values

### OUTPUT_BT

    public static final String OUTPUT_BT

See Also:
  Constant Field Values

### OUTPUT_BBT

    public static final String OUTPUT_BBT

See Also:
  Constant Field Values

### OUTPUT_SQ

    public static final String OUTPUT_SQ

See Also:
  Constant Field Values

### OUTPUT_SB

    public static final String OUTPUT_SB

See Also:
  Constant Field Values

### PROP_QJOB_PATH

    public static final String PROP_QJOB_PATH

See Also:
  Constant Field Values

### PROP_OUPTUT_BBT_PRODUCTS

    public static final String PROP_OUPTUT_BBT_PRODUCTS

See Also:
  Constant Field Values

### PROP_OUTER_PROD_BLOCK_HEIGHT

    public static final String PROP_OUTER_PROD_BLOCK_HEIGHT

See Also:
  Constant Field Values

### PROP_RHAT_BROADCAST

    public static final String PROP_RHAT_BROADCAST

See Also:
  Constant Field Values

### PROP_XI_PATH

    public static final String PROP_XI_PATH

See Also:
  Constant Field Values

### PROP_NV

    public static final String PROP_NV

See Also:
  Constant Field Values

Method Detail

### run

    public static void run(org.apache.hadoop.conf.Configuration conf,
                           org.apache.hadoop.fs.Path[] inputPathA,
                           org.apache.hadoop.fs.Path inputPathQJob,
                           org.apache.hadoop.fs.Path xiPath,
                           org.apache.hadoop.fs.Path outputPath,
                           int minSplitSize,
                           int k,
                           int p,
                           int btBlockHeight,
                           int numReduceTasks,
                           boolean broadcast,
                           Class<? extends org.apache.hadoop.io.Writable> labelClass,
                           boolean outputBBtProducts)
                    throws ClassNotFoundException,
                           InterruptedException,
                           IOException

  Throws:
    `ClassNotFoundException`
    `InterruptedException`
    `IOException`

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.